# Juniper Networks Remote Plugin

## How to spin up the lab environment:

1. Install vagrant
2. Install vagrant plugins: `vagrant plugin install vagrant-host vagrant-host-shell vagrant-junos vagrant-share`

3. Install ansible
4. Install the Juniper.junos role: `ansible-galaxy --force install Juniper.junos`

5. Install the python requirements: `pip install junos-eznc jxmlease`

6. `git clone https://github.com/ksator/junos-orchestration-with-vagrant.git`
7. `cd junos-orchestration-with-vagrant/3vsrx-v2`
8. `vagrant up`

9. Test that the devices are running and reporting: `python programatic_access/python/print_facts_vagrant.py`

## How to test the plugin

1. Update `properties.json` with your localhost IPs
2. `oneagent_sim`


## Metrics

| Metric              |Description                                                             |Unit |  Dimension |
| -----------------   |----------------------------------------------------------------------- | --- |---------- |
*Device Status*| Whether or not the process was able to connect to the device |Percent| 
*Memory Wired*| Amount of total memory wired in the system that never paged out. |Percent| 
*Memory Active*| Amount of total memory actively in use |Percent| 
*Load Average - 1m*| Number of jobs in a run queue or waiting for the CPU resource |Count| 
*Input Bytes*| Input Bytes Per Second |BytePerSecond|Interface
*Output Bytes*| Input Bytes Per Second |BytePerSecond|Interface
*Queued Packets*| Packets sent to the queue |Count|Queue
*Transmitted Packets*| Packets transmitted in the queue |Count|Queue
*Dropped Packets*| Packets dropped in the queue|Count|Queue
*Input Errors*| Sum of the incoming frame aborts and FCS errors |Count|Interface
*Input Drops*| Number of packets dropped |Count|Interface
*Framing Errors*| Number of packets received with an invalid frame checksum |Count|Interface
*Input Discards*| Packets not recognized, protocols that the JUNOS software does not handle |Count|Interface
*Output Errors*| Sum of the outgoing frame aborts and FCS errors |Count|Interface
*Output Collisions*| The number of Ethernet collisions |Count|Interface
*Output Drops*| The number of packets which are dropped by the output queue |Count|Interface
*Flow Input Policy Bytes*| Number of Bytes received by the Flow module |Byte|Interface
*Flow Output Policy Bytes*| Number of Bytes sent by the Flow module |Byte|Interface
*Packets Sent*| TCP Packets Sent |Count| 
*Packets Received*| TCP Packets Received |Count| 
*Connection Requests*| TCP Connection Requests |Count| 
*Connection Accepts*| TCP Connection Accepts |Count| 
*Connections Established*| TCP Connections Currently Established |Count| 
*Connections Closed*| TCP Connections Closed |Count| 
*Datagrams Received*| UDP Datagrams Received |Count| 
*Datagrams Delivered*| UDP Datagrams Delivered |Count| 
